package com.sparkTutorial.rdd.airports;

import com.sparkTutorial.rdd.commons.Utils;
import org.apache.commons.lang.StringUtils;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;

public class AirportsByLatitudeProblem {

    public static void main(String[] args) throws Exception {

        /* Create a Spark program to read the airport data from in/airports.text,  find all the airports whose latitude are bigger than 40.
           Then output the airport's name and the airport's latitude to out/airports_by_latitude.text.

           Each row of the input file contains the following columns:
           Airport ID, Name of airport, Main city served by airport, Country where airport is located, IATA/FAA code,
           ICAO Code, Latitude, Longitude, Altitude, Timezone, DST, Timezone in Olson format

           Sample output:
           "St Anthony", 51.391944
           "Tofino", 49.082222
           ...
         */

        SparkConf sparkConf = new SparkConf().setAppName("airportsByLatitude").setMaster("local[*]");

        JavaSparkContext javaSparkContext = new JavaSparkContext(sparkConf);


        JavaRDD<String> airports = javaSparkContext.textFile("in/airports.text");
        //JavaRDD<String> airportsinUsa = airports.filter(lines->lines.split(Utils.COMMA_DELIMITER)[3].equals("\"United States\""));


        JavaRDD<String> airportsWithLatituteGreater_40 = airports.filter(line-> Float.valueOf(line.split(Utils.COMMA_DELIMITER)[6])>40);

        JavaRDD<String> airportsWithLatituteGreater40 = airportsWithLatituteGreater_40.map(line ->
        {
            String [] temp = line.split(Utils.COMMA_DELIMITER);
            return StringUtils.join(new String[] {temp[1], temp[6]},",");
        });

        airportsWithLatituteGreater40.saveAsTextFile("out/airports_by_latitude.text");




    }
}
